<?php
/**
 * @package    Joomla.Site
 * @subpackage Modules JMG Article Slider
 * @link http://joomega.com
 * @copyright   Copyright (C) 2021 - 2029 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

class modJmgArticlesliderHelper
{
	public static function getFunktion($params)
    {   
		return $params;
    }

	public static function getDownloadId()
    {    
		// Get plugin jmg license manager
		$plugin = JPluginHelper::getPlugin('system', 'jmglicensemgr');
		// Check if plugin is enabled
		if ($plugin){
			// Get plugin params
			$pluginParams = new JRegistry($plugin->params);
			$key = $pluginParams->get('key');
			return $key;
		}
    }
	
	public static function getArticles($catid,$ordering,$max_length)
    {   
		
		$catids = self::getCatids($catid);
		$lang = JFactory::getLanguage();
		$db = JFactory::getDbo();     
		$query = $db->getQuery(true);     
		$query->select('id,catid,title,images,SUBSTRING(introtext, 1, '.$max_length.') AS text');
		$query->from('#__content');
			
		foreach($catids as $key=>$id){
			if($key == 0){
				$query->where(array('state = 1', 'catid = '.$id->id, 'language = '.$db->quote($lang->getTag())));
				$query->orwhere(array('state = 1', 'catid = '.$id->id, 'language = '.$db->quote('*')));
			}
			else{
				$query->extendWhere('OR', array('state = 1', 'catid = '.$id->id, 'language = '.$db->quote($lang->getTag())));
				$query->extendWhere('OR', array('state = 1', 'catid = '.$id->id, 'language = '.$db->quote('*')));
			}
		}
		
		$query->order($ordering);
		$db->setQuery($query);
		
		$rows = $db->loadObjectList();
		
		return $rows;
    }
	
	public static function getCatids($catid)
    {   
		$db = JFactory::getDbo();     
		$query = $db->getQuery(true);     
		$query->select('id')
		 ->from('#__categories')
		 ->where(array('published = 1', 'id = '.$catid))
		 ->orwhere(array('published = 1', 'parent_id = '.$catid));
		$db->setQuery($query);
		$ids = $db->loadObjectList();
		
		return $ids;
    }
}
?>